#ifndef _MATRIX_
#define _MATRIX_

#include <stdexcept>
using namespace std;

template<typename T>
class Matriz {
private:
    int  nlinhas;
    int  ncols;
    T ** mat;
public:
    Matriz( int nlinhas, int ncols ) throw(runtime_error):
        nlinhas( nlinhas ), ncols( ncols ) {
        
        if( nlinhas <= 0 || ncols <= 0 )
            throw runtime_error("Linhas ou colunas inválidas" );
        
        mat = new T*[nlinhas];
        for(int i = 0; i < nlinhas; i++ )
            mat[i] = new T[ncols];
    }
    
    T& operator()( int i, int j ) throw (runtime_error){
        if( i >= 0 && i < nlinhas && j >= 0 && j < ncols )
            return mat[i][j];
        else
            throw runtime_error("índice inválido" );
    } 
    int getNumLinhas() {
        return nlinhas;
    }
    int getNumColunas() {
        return ncols;
    }
    
};
#endif
